;; Experiments on aliasing across vp-sets in *Lisp

(in-package '*lisp)

(def-vp-set vpA '(8192))	;; Base vp-set

(def-vp-set vpB NIL
   :geometry-definition-form
	(create-geometry :dimensions '(8192 4)
			 :weights    '(0 8)
			 :ordering   '(:send-order :send-order))
)


(defun axisB (c)  ;; c is coordinate - either 0 or 1
  (let ((x 0)  (cx (if (zerop c) 1 0)))
   (*with-vp-set vpB
    (setq x (*when (zerop!! (self-address-grid!! (!! cx)))
		(*logior (self-address!!))))
    (format t "~15,'0B~%" x)
    x))
)

;; A few pvars:

(*proclaim '(type (field-pvar 15) x y z))

(*defvar x (self-address!!) "x" vpA)

(*defvar y (self-address-grid!! (!! 0)) "y" vpB)

(*defvar z (self-address-grid!! (!! 1)) "z" vpB)

;; To become aliases:

(*defvar xa NIL "xa" vpB)

(*defvar ya NIL "yz" vpA)

(*defvar za NIL "za" vpA)

;; Create aliases after *cold-boot:

(defun mk-alias ()
  (*with-vp-set vpA (setq ya (alias!! y))  (setq za (alias!! z)))
  (*with-vp-set vpB (setq xa (alias!! x)))
)
